<template>
    <div class="edit-popup">
        <popup ref="popupRef" :title="popupTitle" :async="true" width="550px" @confirm="handleSubmit"
            @close="handleClose">
            <el-form ref="formRef" :model="formData" label-width="90px" :rules="formRules">
                <el-form-item label="所属菜单" prop="menu">
                    <el-select class="flex-1" v-model="formData.menu" clearable placeholder="请选择所属菜单">
                        <el-option v-for="(item, index) in dictData.consult_menu" :key="index" :label="item.name"
                            :value="item.value" />
                    </el-select>
                </el-form-item>
                <el-form-item label="目录分类" prop="name">
                    <el-input v-model="formData.name" clearable placeholder="请输入目录分类" />
                </el-form-item>
            </el-form>
        </popup>
    </div>
</template>

<script lang="ts" setup name="consultDirectoryEdit">
import type { FormInstance } from 'element-plus'
import Popup from '@/components/popup/index.vue'
import { apiConsultDirectoryAdd, apiConsultDirectoryEdit, apiConsultDirectoryDetail } from '@/api/consult_directory'
import { timeFormat } from '@/utils/util'
import type { PropType } from 'vue'
defineProps({
    dictData: {
        type: Object as PropType<Record<string, any[]>>,
        default: () => ({})
    }
})
const emit = defineEmits(['success', 'close'])
const formRef = shallowRef<FormInstance>()
const popupRef = shallowRef<InstanceType<typeof Popup>>()
const mode = ref('add')


// 弹窗标题
const popupTitle = computed(() => {
    return mode.value == 'edit' ? '编辑项目咨询--全过程咨询目录' : '新增项目咨询--全过程咨询目录'
})

// 表单数据
const formData = reactive({
    id: '',
    menu: '',
    name: '',
})


// 表单验证
const formRules = reactive<any>({
    menu: [{
        required: true,
        message: '请输入所属菜单',
        trigger: ['blur']
    }],
    name: [{
        required: true,
        message: '请输入目录分类',
        trigger: ['blur']
    }]
})


// 获取详情
const setFormData = async (data: Record<any, any>) => {
    for (const key in formData) {
        if (data[key] != null && data[key] != undefined) {
            //@ts-ignore
            formData[key] = data[key]
        }
    }

    formData.menu = String(formData.menu)
}

const getDetail = async (row: Record<string, any>) => {
    const data = await apiConsultDirectoryDetail({
        id: row.id
    })
    setFormData(data)
}


// 提交按钮
const handleSubmit = async () => {
    await formRef.value?.validate()
    const data = { ...formData, }
    mode.value == 'edit'
        ? await apiConsultDirectoryEdit(data)
        : await apiConsultDirectoryAdd(data)
    popupRef.value?.close()
    emit('success')
}

//打开弹窗
const open = (type = 'add') => {
    mode.value = type
    popupRef.value?.open()
}

// 关闭回调
const handleClose = () => {
    emit('close')
}



defineExpose({
    open,
    setFormData,
    getDetail
})
</script>
